using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using EasyImages;
using System.IO;
using System.Threading;
namespace EasyImages
{
    public partial class CameraServer : Form
    {
        private string cameraname = "DefaultCamera";
        private Size framesize = new Size(320, 240);
        private float framerate = 10f;
        private bool started = false;
        Camera c;

        public CameraServer()
        {
            InitializeComponent();
            c = new Camera(this);
        }

        #region Properties
        public Size FrameSize
        {
            get
            {
                return framesize;
            }
            set
            {
                framesize = value;
            }
        }

        public float MaxFrameRate
        {
            get
            {
                return framerate;
            }
            set
            {
                framerate = value;
            }
        }

        public string CameraName
        {
            get
            {
                return cameraname;
            }
            set
            {
                cameraname = value;
            }
        }

        public bool IsStarted
        {
            get
            {
                return started;
            }
        }
        #endregion

        public void Start()
        {
            if (started == true) return;

            c.Width = framesize.Width;
            c.Height = framesize.Height;

            try
            {
                c.FramesPerSecond = framerate;
            }
            catch { c.FramesPerSecond = 10f; }

            c.StartFileMapping(cameraname);
            started = true;
        }

        public void Stop()
        {
            c.Stop();
            started = false;
        }

        private void CameraServer_FormClosing(object sender, FormClosingEventArgs e)
        {
            c.Stop();
            started = false;
        }
    }
}